%BOXCARINFLOW - inflow into a boxcartrain
%   This simple function is used to add biomass to a boxcartrain in a model definition. It returns a vector 
%   with all zeros except for the first element, which is filled with the inflow.
%
%
%   Usage:
%   res=BOXCARINFLOW(VAR, INFLOW) - returns a zero vector of sizeof(VAR) with inflow in the first element.
%
%   See also BOXCARTRAIN, MODEL, INSIM

%   Copyright 2011 WUR
%   Revision: 1.0.7 $ $Date: 27-Oct-2011 17:17:07 $
function res=boxcarinflow(A,inflow)
res=zeros(size(A));
res(1)=inflow;
