function out = i_paranaldialog(answer,flag)
global g_grind;
if nargin==0
   answer=[];
end;
if isempty(answer)| isstruct(answer)
   if isstruct(answer)
      out = i_paranaldialog('initstruct',answer);
   else
      out=i_paranaldialog('initstruct');
   end;
   paranaldlg;
   if isempty(g_grind.pars)
      g_grind.pars = {' '};
   end;
   set(findobj(gcf,'tag','ParamPopup'),'string',g_grind.pars);
   f = findincell(out.par{1}, g_grind.pars);
   if f > 0
      set(findobj(gcf,'tag','ParamPopup'),'value',f);
   end;
   set(findobj(gcf,'tag','StartEdit'),'string',num2str(out.start(1)));
   set(findobj(gcf,'tag','EndEdit'),'string',num2str(out.nend(1)));
   set(findobj(gcf,'tag','StepsEdit'),'string',num2str(out.steps(1)));
   set(findobj(gcf,'tag','StabilEdit'),'string',num2str(out.stabil));
   set(findobj(gcf,'tag','WritingEdit'),'string',num2str(out.writing));
   set(findobj(gcf,'tag','OutputPopup'),'value',out.outputtype)
   set(findobj(gcf,'tag','LinesPopup'),'value',out.lines+1);
   set(findobj(gcf,'tag','ParamPopup2'),'string',[{'none'},g_grind.pars]);
   f = findincell(out.par{2}, g_grind.pars);
   set(findobj(gcf,'tag','ParamPopup2'),'value',f+1);
   set(findobj(gcf,'tag','StartEdit2'),'string',num2str(out.start(2)));
   set(findobj(gcf,'tag','EndEdit2'),'string',num2str(out.nend(2)));
   set(findobj(gcf,'tag','StepsEdit2'),'string',num2str(out.steps(2)));
%   set(findobj(gcf,'tag','DisturbanceEdit'),'string',out.disturbance);
   if ~isfield(answer,'paranal2d')
      if isempty(out.par{2})
         i_paranaldialog('advanced');
      end;
   else
      set(findobj(gcf,'tag','AdvancedButton'),'visible','off');
   end;
   set(gcf, 'userdata', out);
   set(gcf,'WindowStyle','modal');
   uiwait;
   out = get(gcf, 'userdata');
   close(gcf);
else
   switch answer
   case 'outputlist'
      out={'Unchanged' 'Mean' 'Median' 'Maxima' 'Minima' ...
            'Minima+Maxima' 'SD' 'CV' 'Sum' ...
             'Perc05' 'Perc95' 'Range90' 'Min' 'Max' 'Range'};
         %'Returntime'};
   case 'initstruct'
      out.par={'',''};
      out.start=[0,0];
      out.nend=[10,10];
      out.steps=[50 50];
      out.stabil=600;
      out.writing=300;
      out.outputtype=1;
      out.lines=0;
 %     out.disturbance='';
      if (nargin>1)&~isempty(flag)
         answer=flag;
      if isfield(answer,'par')&~isempty(answer.par)
          if ischar(answer.par)
              out.par{1}=strtrim(answer.par);
          else
              out.par{1}=strtrim(answer.par{1}); 
              if length(answer.par)==2
                  out.par{2} = strtrim(answer.par{2});
              end
          end; 
      end;
      if isfield(answer,'start'), out.start(1)=answer.start(1); if length(answer.start)==2, out.start(2)=answer.start(2); end; end;
      if isfield(answer,'nend'), out.nend(1)=answer.nend(1); if length(answer.nend)==2, out.nend(2)=answer.nend(2); end; end;
      if isfield(answer,'steps'), out.steps(1)=answer.steps(1); if length(answer.steps)==2, out.steps(2)=answer.steps(2); end; end;
      if isfield(answer,'stabil'), out.stabil=answer.stabil; end;
      if isfield(answer,'writing'), out.writing=answer.writing; end;
      if isfield(answer,'outputtype'), out.outputtype=answer.outputtype; end;
      if isfield(answer,'lines'), out.lines=answer.lines; end;
  %    if isfield(answer,'disturbance'), out.disturbance=answer.disturbance; end;
      end;
    case 'advanced'
      vis=get(findobj(gcf,'tag','advanced'),'visible');
      if strcmpi(vis(1), 'on');
         setvisible('off')
         set(findobj(gcf,'tag','AdvancedButton'),'string','Advanced');
         p = get(gcf, 'Position');
         p(4) = 300;
         p(2) = p(2) + 70;
         set(gcf, 'Position', p);
         hs=findobj(gcf,'type','uicontrol');
         p = get(hs, 'position');
         for i = 1:length(p)
            p{i}(2) = p{i}(2) - 140;
            if ~strcmpi(get(hs(i),'style'),'pushbutton');
               set(hs(i), 'position', p{i})
            end;
         end;
      else
         setvisible('on');
         set(findobj(gcf,'tag','AdvancedButton'),'string','Hide advanced')
         p = get(gcf, 'Position');
         p(4) = 480;
         p(2) = p(2) - 70;
         set(gcf, 'Position', p);
         hs=findobj(gcf,'type','uicontrol');
         p = get(hs, 'position');
         for i = 1:length(p)
            p{i}(2) = p{i}(2) + 140;
            if ~strcmpi(get(hs(i),'style'),'pushbutton');
               set(hs(i), 'position', p{i})
            end;
         end;
         
      end;
    case 'ok'
      if ~isempty(g_grind.pars)
         ud.par{1}=g_grind.pars{get(findobj(gcbf,'tag','ParamPopup'),'value')};
      end;
      ud.start(1)=evalin('base',get(findobj(gcbf,'tag','StartEdit'),'string'));
      ud.nend(1)=evalin('base',get(findobj(gcbf,'tag','EndEdit'),'string'));
      ud.steps(1)=evalin('base',get(findobj(gcbf,'tag','StepsEdit'),'string'));
      ud.stabil=evalin('base',get(findobj(gcbf,'tag','StabilEdit'),'string'));
      ud.writing=evalin('base',get(findobj(gcbf,'tag','WritingEdit'),'string'));
      ud.outputtype= get(findobj(gcbf,'tag','OutputPopup'),'value');
      ud.lines= get(findobj(gcbf,'tag','LinesPopup'),'value')-1;
      f= get(findobj(gcbf,'tag','ParamPopup2'),'value');
      if f <= 1
         ud.par{2} = '';
      else
         ud.par{2} = g_grind.pars{f - 1};
      end;
      ud.start(2)=evalin('base',get(findobj(gcbf,'tag','StartEdit2'),'string'));
      ud.nend(2)= evalin('base',get(findobj(gcbf,'tag','EndEdit2'),'string'));
      ud.steps(2)= evalin('base',get(findobj(gcbf,'tag','StepsEdit2'),'string'));
 %     ud.disturbance =get(findobj(gcbf,'tag','DisturbanceEdit'),'string');
      set(gcbf, 'userdata', ud);
      uiresume;
    case 'cancel'
      set(gcbf,'userdata',{});
      uiresume;
   end;
end;

function res = findincell(s, c)
res = 0;
for i = 1:length(c)
   if strcmp(c{i}, s)
      res = i;
      break;
   end;
end;

function setvisible(val)
set(findobj(gcf,'tag','advanced'),'visible',val);
set(findobj(gcf,'tag','StartEdit2'),'visible',val);
set(findobj(gcf,'tag','EndEdit2'),'visible',val);
set(findobj(gcf,'tag','StepsEdit2'),'visible',val);
set(findobj(gcf,'tag','OutputPopup'),'visible',val);
set(findobj(gcf,'tag','ParamPopup2'),'visible',val);
%set(findobj(gcf,'tag','DisturbanceEdit'),'visible',val);

function paranaldlg
f=329;
r=22;
f2=305;

h0 = figure('Color',[0.8 0.8 0.8], ...
	'MenuBar','none', ...
	'Name','Parameter analysis', ...
	'NumberTitle','off', ...
	'PaperPosition',[18 180 576 432], ...
	'PaperUnits','points', ...
	'Position',[232 258 504 484], ...
	'Tag','Fig1', ...
	'ToolBar','none');
uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[0.8 0.8 0.8], ...
	'HorizontalAlignment','left', ...
	'ListboxTop',0, ...
	'Position',[23 f 147.75 16], ...
	'String','Name of the parameter to change:', ...
	'Style','text', ...
	'Tag','StaticText1');
uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[1 1 1], ...
	'HorizontalAlignment','left', ...
	'ListboxTop',0, ...
	'Position',[220.5 f 121.5 16], ...
	'String',{' '}, ...
	'Style','popupmenu', ...
	'Tag','ParamPopup', ...
	'Value',1);
uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[0.8 0.8 0.8], ...
	'HorizontalAlignment','left', ...
	'ListboxTop',0, ...
	'Position',[23 f-r 147.75 16], ...
	'String','Start value:', ...
	'Style','text', ...
   'Tag','StaticText1');
uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[1 1 1], ...
	'HorizontalAlignment','left', ...
	'ListboxTop',0, ...
	'Position',[220 f-r 121.5 16], ...
	'String','1', ...
	'Style','edit', ...
	'Tag','StartEdit');
uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[0.8 0.8 0.8], ...
	'HorizontalAlignment','left', ...
	'ListboxTop',0, ...
	'Position',[23 f-r*2 147.75 16], ...
	'String','End value:', ...
	'Style','text', ...
	'Tag','StaticText1');
uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[1 1 1], ...
	'HorizontalAlignment','left', ...
	'ListboxTop',0, ...
	'Position',[220 f-r*2 121.5 16], ...
	'String','10', ...
	'Style','edit', ...
	'Tag','EndEdit');
uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[0.8 0.8 0.8], ...
	'HorizontalAlignment','left', ...
	'ListboxTop',0, ...
	'Position',[23 f-r*3 147.75 16], ...
	'String','Number of steps for changing:', ...
	'Style','text', ...
	'Tag','StaticText1');
uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[1 1 1], ...
	'HorizontalAlignment','left', ...
	'ListboxTop',0, ...
	'Position',[220 f-r*3 121.5 16], ...
	'String','50', ...
	'Style','edit', ...
	'Tag','StepsEdit');
uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[0.8 0.8 0.8], ...
	'HorizontalAlignment','left', ...
	'ListboxTop',0, ...
	'Position',[23 f-r*4 147.75 16], ...
	'String','Period of stabilizing per step (time units)', ...
	'Style','text', ...
	'Tag','StaticText1');
uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[1 1 1], ...
	'HorizontalAlignment','left', ...
	'ListboxTop',0, ...
	'Position',[220 f-r*4 121.5 16], ...
	'String','600', ...
	'Style','edit', ...
   'Tag','StabilEdit');
uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[0.8 0.8 0.8], ...
	'HorizontalAlignment','left', ...
	'ListboxTop',0, ...
	'Position',[23 f-r*5 182.25 16], ...
	'String','Period of plotting per time step (time units, min.=0)', ...
	'Style','text', ...
	'Tag','StaticText1');
uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[1 1 1], ...
	'HorizontalAlignment','left', ...
	'ListboxTop',0, ...
	'Position',[220 f-r*5 121.5 16], ...
	'String','300', ...
	'Style','edit', ...
   'Tag','WritingEdit');
uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[0.8 0.8 0.8], ...
	'HorizontalAlignment','left', ...
	'ListboxTop',0, ...
	'Position',[23 f-r*6 180.75 16], ...
	'String','Type of plot:', ...
	'Style','text', ...
   'Tag','StaticText2');
uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[1 1 1], ...
	'ListboxTop',0, ...
	'Position',[220 f-r*6 121.5 16], ...
	'String',{'scatter plot (dots)' 'line plot' 'contour (2D only)' 'surf (2D only)'}, ...
	'Style','popupmenu', ...
	'Tag','LinesPopup', ...
   'Value',1);
uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[0.8 0.8 0.8], ...
	'HorizontalAlignment','left', ...
	'ListboxTop',0, ...
	'Position',[23 f2-r*7 147.75 16], ...
	'String','Name of a second parameter to change:', ...
	'Style','text', ...
   'Tag','advanced');
uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[1 1 1], ...
	'HorizontalAlignment','left', ...
	'ListboxTop',0, ...
	'Position',[220 f2-r*7 121.5 16], ...
	'String',{' '}, ...
	'Style','popupmenu', ...
	'Tag','ParamPopup2', ...
	'Value',1);

uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[0.8 0.8 0.8], ...
	'HorizontalAlignment','left', ...
	'ListboxTop',0, ...
	'Position',[23 f2-r*8 147.75 16], ...
	'String','Start value:', ...
	'Style','text', ...
	'Tag','advanced');
uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[1 1 1], ...
	'HorizontalAlignment','left', ...
	'ListboxTop',0, ...
	'Position',[220 f2-r*8 121.5 16], ...
	'String','0', ...
	'Style','edit', ...
	'Tag','StartEdit2');
uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[0.8 0.8 0.8], ...
	'HorizontalAlignment','left', ...
	'ListboxTop',0, ...
	'Position',[23 f2-r*9 147.75 16], ...
	'String','End value:', ...
	'Style','text', ...
   'Tag','advanced');
uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[1 1 1], ...
	'HorizontalAlignment','left', ...
	'ListboxTop',0, ...
	'Position',[220 f2-r*9 121.5 16], ...
	'String','10', ...
	'Style','edit', ...
	'Tag','EndEdit2');

uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[1 1 1], ...
	'HorizontalAlignment','left', ...
	'ListboxTop',0, ...
	'Position',[220 f2-r*10 121.5 16], ...
	'String','50', ...
	'Style','edit', ...
	'Tag','StepsEdit2');
uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[0.8 0.8 0.8], ...
	'HorizontalAlignment','left', ...
	'ListboxTop',0, ...
	'Position',[23 f2-r*10 147.75 16], ...
	'String','Number of steps for changing:', ...
	'Style','text', ...
   'Tag','advanced');

% uicontrol('Parent',h0, ...
% 	'Units','points', ...
% 	'BackgroundColor',[0.8 0.8 0.8], ...
% 	'HorizontalAlignment','left', ...
% 	'ListboxTop',0, ...
% 	'Position',[23 f2-r*11 147.75 16], ...
% 	'String','Disturbance:', ...
% 	'Style','text', ...
% 	'Tag','advanced');
% uicontrol('Parent',h0, ...
% 	'Units','points', ...
% 	'BackgroundColor',[1 1 1], ...
% 	'HorizontalAlignment','left', ...
% 	'ListboxTop',0, ...
% 	'Position',[220 f2-r*11 121.5 16], ...
% 	'Style','edit', ...
% 	'Tag','DisturbanceEdit');
uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[0.8 0.8 0.8], ...
	'HorizontalAlignment','left', ...
	'ListboxTop',0, ...
	'Position',[23 f2-r*11 182.25 16], ...
	'String','Output:', ...
	'Style','text', ...
   'Tag','advanced');
uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[1 1 1], ...
	'HorizontalAlignment','left', ...
	'ListboxTop',0, ...
	'Position',[220 f2-r*11 121.5 16], ...
   'String', i_paranaldialog('outputlist'), ...
	'Style','popupmenu', ...
	'Tag','OutputPopup', ...
	'Value',1);

uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[0.8 0.8 0.8], ...
	'Callback','i_paranaldialog(''cancel'')', ...
	'ListboxTop',0, ...
	'Position',[96 20 74.25 18.75], ...
	'String','Cancel', ...
	'Tag','Pushbutton2');
uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[0.8 0.8 0.8], ...
	'Callback','i_paranaldialog(''ok'')', ...
	'ListboxTop',0, ...
	'Position',[180 20 74.25 18.75], ...
	'String','OK', ...
	'Tag','Pushbutton2');
uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[0.8 0.8 0.8], ...
	'Callback','i_paranaldialog(''advanced'')', ...
	'ListboxTop',0, ...
	'Position',[265.5 20 74.25 18.75], ...
	'String','Hide advanced', ...
	'Tag','AdvancedButton');

