%ERA - Erase and close all figures
%   Close all open figures.
%
%   See also E2N, E3R, E2R, E2P

%   Copyright 2011 WUR
%   Revision: 1.0.7 $ $Date: 27-Oct-2011 17:17:08 $
function era(allfigures)
if nargin == 0
   allfigures = 0;
else
   if strcmpi(allfigures, 'all')
      allfigures = 1;
   end;
end;
if allfigures
   close all hidden;
else
   ch = findobj(get(0,'Children'), 'flat','type','figure');
   max = i_figno('maxno');
   i2 = i_figno('combfig');
   i3=i_figno('dialog');
   for i = 1:length(ch)
      if (ch(i) <= max) & (ch(i) ~= i2)& (ch(i) ~= i3)
         figure(ch(i));
         close;
      end;
   end;
end;
