%NDX2SPARSE - create sparse matrix with ones on the indexed values
%
% Usage:
%   A=NDX2SPARSE(NDX)
%
% See also:
% SPARSE2NDX, CREATE_NETWORK
function A=ndx2sparse(ndxs)
n=max(max(ndxs));
A=sparse(n,n);
for i = 1:size(ndxs,1)
   A(ndxs(i,1), ndxs(i,2)) = 1;
   A(ndxs(i,2), ndxs(i,1)) = 1; %the connection goes two ways
end;