function res = i_depthslider(flag, par1,par2)
% This is the machine-generated representation of a Handle Graphics object
% and its children.  Note that handle values may change when these objects
% are re-created. This may cause problems with any callbacks written to
% depend on the value of the handle at the time the object was saved.
% This problem is solved by saving the output as a FIG-file.
%
% To reopen this object, just type the name of the M-file at the MATLAB
% prompt. The M-file and its associated MAT-file must be on your path.
%
% NOTE: certain newer features in MATLAB may not have been saved in this
% M-file due to limitations of this format, which has been superseded by
% FIG-files.  Figures which have been annotated using the plot editor tools
% are incompatible with the M-file/MAT-file format, and should be saved as
% FIG-files.

if nargin == 0
   flag = 'init';
end;
switch flag
 case 'init'
   if nargin < 2
      par1 = get(gca, 'currentpoint');
      par2 = {get(get(gca,'xlabel'),'string'),get(get(gca,'ylabel'),'string'),get(get(gca,'zlabel'),'string')};
   end;
   pos=get(gcf,'position');
   ud.initpnt = par1;
   ud.labels =par2;
   ud.curval=[];
   ud.depth = 0;
   h0=figure('Color',[0.8 0.8 0.8], ...
      'MenuBar','none', ...
      'Name','Clicked in 3D figure', ...
      'NumberTitle','off', ...
      'PaperPosition',[18 180 576 432], ...
      'PaperUnits','points', ...
      'Position',[pos(1)+pos(3) pos(2) 180 426], ...
      'Tag','Fig1', ...
      'ToolBar','none');
   h1 = uicontrol('Parent',h0, ...
      'Units','points', ...
      'BackgroundColor',[1 1 1], ...
      'Callback','i_depthslider(''changed'')', ...
      'ListboxTop',0, ...
      'Position',[10 43.5 21.75 195.75], ...
      'Style','slider', ...
      'Tag','DepthSlider');
   h1 = uicontrol('Parent',h0, ...
      'Units','points', ...
      'BackgroundColor',[0.8 0.8 0.8], ...
      'HorizontalAlignment','left', ...
      'ListboxTop',0, ...
      'Position',[10 276.75 120.75 23.25], ...
      'String','Indicate the depth in the figure', ...
      'Style','text', ...
      'Tag','StaticText1');
   h1 = uicontrol('Parent',h0, ...
      'Units','points', ...
      'BackgroundColor',[0.8 0.8 0.8], ...
      'HorizontalAlignment','left', ...
      'ListboxTop',0, ...
      'Position',[10 19.5 45 15], ...
      'String','To the front', ...
      'Style','text', ...
      'Tag','StaticText2');
   h1 = uicontrol('Parent',h0, ...
      'Units','points', ...
      'BackgroundColor',[0.8 0.8 0.8], ...
      'HorizontalAlignment','left', ...
      'ListboxTop',0, ...
      'Position',[10 248.25 45 15], ...
      'String','To the back', ...
      'Style','text', ...
      'Tag','StaticText2');
   h1 = uicontrol('Parent',h0, ...
      'Units','points', ...
      'BackgroundColor',[0.8 0.8 0.8], ...
      'HorizontalAlignment','left', ...
      'ListboxTop',0, ...
      'Position',[50 164.25 100 15], ...
      'String','X=', ...
      'Style','text', ...
      'Tag','XText');
   h1 = uicontrol('Parent',h0, ...
      'Units','points', ...
      'BackgroundColor',[0.8 0.8 0.8], ...
      'HorizontalAlignment','left', ...
      'ListboxTop',0, ...
      'Position',[50 138.75 100 15], ...
      'Style','text', ...
      'Tag','YText');
   h1 = uicontrol('Parent',h0, ...
      'Units','points', ...
      'BackgroundColor',[0.8 0.8 0.8], ...
      'HorizontalAlignment','left', ...
      'ListboxTop',0, ...
      'Position',[50 113.25 100 15], ...
      'Style','text', ...
      'Tag','ZText');
   h1 = uicontrol('Parent',h0, ...
      'Units','points', ...
      'BackgroundColor',[0.8 0.8 0.8], ...
      'Callback','i_depthslider(''ok'')', ...
      'ListboxTop',0, ...
      'Position',[50 75.75 60.75 17.25], ...
      'String','OK', ...
      'Tag','Pushbutton1');
   h1 = uicontrol('Parent',h0, ...
      'Units','points', ...
      'BackgroundColor',[0.8 0.8 0.8], ...
      'Callback','i_depthslider(''cancel'')', ...
      'ListboxTop',0, ...
      'Position',[50 47.25 60.75 17.25], ...
      'String','Cancel', ...
      'Tag','Pushbutton1');
   set(h0, 'userdata', ud);
   set(h0,'WindowStyle','modal');
   i_depthslider('changed', h0);
   uiwait;
   if ishandle(h0)
     ud= get(h0,'userdata');
     res=ud.curval';
     close(h0);
   else
      res=[];
   end;
 case 'ok'
   uiresume;
 case 'cancel'
    h=gcbf;
    if isempty(h)
        h=gcf;
    end;
    ud= get(h,'userdata');
    ud.curval=[];
    set(h,'userdata',ud)
   uiresume;
case 'changed'
   if nargin==2
      h=par1;
    else
    h=gcbf;
    if isempty(h)
        h=gcf;
     end;
    end;
    ud= get(h,'userdata');
    if ~isempty(ud)
    h1=findobj(h,'tag','DepthSlider');
    ud.depth=get(h1,'value');
    ud.curval=ud.initpnt(1,:)+ud.depth*(ud.initpnt(2,:)-ud.initpnt(1,:));
    h1=findobj(h,'tag','XText');
    set(h1,'string',sprintf('%s = %g',ud.labels{1},ud.curval(1)));
    h1=findobj(h,'tag','YText');
    set(h1,'string',sprintf('%s = %g',ud.labels{2},ud.curval(2)));
    h1=findobj(h,'tag','ZText');
    set(h1,'string',sprintf('%s = %g',ud.labels{3},ud.curval(3)));
    set(h,'userdata',ud);
    end;
 otherwise
end;
