function result = tempsum(fun, critvalue, resets)
if nargin == 0
   fun = 'T';
end;
if nargin < 2
   critvalue = 0;
end;
if nargin < 3
   resets = [];
end;
global g_t;
if ischar(fun)
   funval = i_getoutfun(fun);
   x = g_t;
else
   funval = fun;
   x = 1:length(funval);
end;
sumval = max(funval, critvalue) - critvalue;
if length(resets)==1
   resets=1:resets(1):x(end);
end;
resets = sort(resets);
ndx(1) = 1;
for i = 1:length(resets)
   xx = abs(x - resets(i));
   f=find(xx == min(xx));
   ndx(i + 1) = f(1);
end;
ndx(end + 1) = length(funval)+1;
result = [];
for i = 2:length(ndx)
   if ndx(i - 1) < ndx(i)
      if isempty(result)
         result = cumsum(sumval(ndx(i - 1):ndx(i) - 1));
      else
         result = [result; cumsum(sumval(ndx(i - 1):ndx(i) - 1)) ];
      end;
   end;
end;

